diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/model/pyviz.h ns-3.43/src/visualizer/model/pyviz.h
--- ns-3.42/src/visualizer/model/pyviz.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/model/pyviz.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2008 INESC Porto
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * C++ helper functions for use by the python visualizer (for things
  * Python is too slow at).
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/model/visual-simulator-impl.cc ns-3.43/src/visualizer/model/visual-simulator-impl.cc
--- ns-3.42/src/visualizer/model/visual-simulator-impl.cc	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/model/visual-simulator-impl.cc	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Gustavo Carneiro
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gustavo Carneiro <gjcarneiro@gmail.com> <gjc@inescporto.pt>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/model/visual-simulator-impl.h ns-3.43/src/visualizer/model/visual-simulator-impl.h
--- ns-3.42/src/visualizer/model/visual-simulator-impl.h	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/model/visual-simulator-impl.h	2024-10-09 16:41:10.104656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2010 Gustavo Carneiro
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gustavo Carneiro  <gjcarneiro@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/visualizer/core.py ns-3.43/src/visualizer/visualizer/core.py
--- ns-3.42/src/visualizer/visualizer/core.py	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/visualizer/core.py	2024-10-09 16:41:10.104656700 -0700
@@ -25,11 +25,7 @@
 import math
 import os
 import sys
-
-try:
-    import threading
-except ImportError:
-    import dummy_threading as threading
+import threading
 
 try:
     import pygraphviz
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/visualizer/visualizer/ipython_view.py ns-3.43/src/visualizer/visualizer/ipython_view.py
--- ns-3.42/src/visualizer/visualizer/ipython_view.py	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/visualizer/visualizer/ipython_view.py	2024-10-09 16:41:10.104656700 -0700
@@ -368,6 +368,8 @@
     #  _showReturned function
     ## @var prompt
     #  prompt function
+    ## @var no_input_splitter
+    # no input splitter
 
     """
     Specialized text view for console-like workflow.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/CMakeLists.txt ns-3.43/src/wifi/CMakeLists.txt
--- ns-3.42/src/wifi/CMakeLists.txt	2024-05-29 15:29:47.188073900 -0700
+++ ns-3.43/src/wifi/CMakeLists.txt	2024-10-09 16:41:10.108656600 -0700
@@ -27,6 +27,10 @@
     model/channel-access-manager.cc
     model/ctrl-headers.cc
     model/edca-parameter-set.cc
+    model/eht/advanced-ap-emlsr-manager.cc
+    model/eht/advanced-emlsr-manager.cc
+    model/eht/ap-emlsr-manager.cc
+    model/eht/default-ap-emlsr-manager.cc
     model/eht/default-emlsr-manager.cc
     model/eht/eht-capabilities.cc
     model/eht/eht-configuration.cc
@@ -186,6 +190,10 @@
     model/channel-access-manager.h
     model/ctrl-headers.h
     model/edca-parameter-set.h
+    model/eht/advanced-ap-emlsr-manager.h
+    model/eht/advanced-emlsr-manager.h
+    model/eht/ap-emlsr-manager.h
+    model/eht/default-ap-emlsr-manager.h
     model/eht/default-emlsr-manager.h
     model/eht/eht-capabilities.h
     model/eht/eht-configuration.h
@@ -298,7 +306,6 @@
     model/wifi-mac.h
     model/wifi-mgt-header.h
     model/wifi-mode.h
-    model/wifi-mpdu-type.h
     model/wifi-mpdu.h
     model/wifi-net-device.h
     model/wifi-opt-field.h
@@ -323,11 +330,14 @@
     model/wifi-tx-parameters.h
     model/wifi-tx-timer.h
     model/wifi-tx-vector.h
+    model/wifi-types.h
+    model/wifi-units.h
     model/wifi-utils.h
     model/yans-error-rate-model.h
     model/yans-wifi-channel.h
     model/yans-wifi-phy.h
     model/wifi-spectrum-value-helper.h
+    test/wifi-mlo-test.h
 )
 
 build_lib(
@@ -370,4 +380,5 @@
     test/wifi-phy-cca-test.cc
     test/wifi-non-ht-dup-test.cc
     test/wifi-phy-mu-mimo-test.cc
+    test/wifi-operating-channel-test.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/reference/Bianchi11a.m ns-3.43/src/wifi/examples/reference/Bianchi11a.m
--- ns-3.42/src/wifi/examples/reference/Bianchi11a.m	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/reference/Bianchi11a.m	2024-10-09 16:41:10.112656800 -0700
@@ -1,30 +1,6 @@
 % Copyright 2020 University of Washington
 %
-% Redistribution and use in source and binary forms, with or without
-% modification, are permitted provided that the following conditions are met:
-%
-% 1. Redistributions of source code must retain the above copyright notice,
-% this list of conditions and the following disclaimer.
-%
-% 2. Redistributions in binary form must reproduce the above copyright notice,
-% this list of conditions and the following disclaimer in the documentation
-% and/or other materials provided with the distribution.
-%
-% 3. Neither the name of the copyright holder nor the names of its contributors
-% may be used to endorse or promote products derived from this software without
-% specific prior written permission.
-%
-% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-% POSSIBILITY OF SUCH DAMAGE.
+% SPDX-License-Identifier: BSD-3-Clause
 %
 % Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/reference/bianchi11ax.py ns-3.43/src/wifi/examples/reference/bianchi11ax.py
--- ns-3.42/src/wifi/examples/reference/bianchi11ax.py	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/reference/bianchi11ax.py	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 #
 # Copyright 2020 University of Washington
 #
-# This program is free software; you can redistribute it and/or modify
-# it under the terms of the GNU General Public License version 2 as
-# published by the Free Software Foundation;
-#
-# This program is distributed in the hope that it will be useful,
-# but WITHOUT ANY WARRANTY; without even the implied warranty of
-# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-# GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License
-# along with this program; if not, write to the Free Software
-# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+# SPDX-License-Identifier: GPL-2.0-only
 #
 # Authors:  Hao Yin and Sebastien Deronne
 #
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/reference/Bianchi11b.m ns-3.43/src/wifi/examples/reference/Bianchi11b.m
--- ns-3.42/src/wifi/examples/reference/Bianchi11b.m	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/reference/Bianchi11b.m	2024-10-09 16:41:10.112656800 -0700
@@ -1,30 +1,6 @@
 % Copyright 2020 University of Washington
 %
-% Redistribution and use in source and binary forms, with or without
-% modification, are permitted provided that the following conditions are met:
-%
-% 1. Redistributions of source code must retain the above copyright notice,
-% this list of conditions and the following disclaimer.
-%
-% 2. Redistributions in binary form must reproduce the above copyright notice,
-% this list of conditions and the following disclaimer in the documentation
-% and/or other materials provided with the distribution.
-%
-% 3. Neither the name of the copyright holder nor the names of its contributors
-% may be used to endorse or promote products derived from this software without
-% specific prior written permission.
-%
-% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-% POSSIBILITY OF SUCH DAMAGE.
+% SPDX-License-Identifier: BSD-3-Clause
 %
 % Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/reference/Bianchi11g.m ns-3.43/src/wifi/examples/reference/Bianchi11g.m
--- ns-3.42/src/wifi/examples/reference/Bianchi11g.m	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/reference/Bianchi11g.m	2024-10-09 16:41:10.112656800 -0700
@@ -1,30 +1,6 @@
 % Copyright 2020 University of Washington
 %
-% Redistribution and use in source and binary forms, with or without
-% modification, are permitted provided that the following conditions are met:
-%
-% 1. Redistributions of source code must retain the above copyright notice,
-% this list of conditions and the following disclaimer.
-%
-% 2. Redistributions in binary form must reproduce the above copyright notice,
-% this list of conditions and the following disclaimer in the documentation
-% and/or other materials provided with the distribution.
-%
-% 3. Neither the name of the copyright holder nor the names of its contributors
-% may be used to endorse or promote products derived from this software without
-% specific prior written permission.
-%
-% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-% POSSIBILITY OF SUCH DAMAGE.
+% SPDX-License-Identifier: BSD-3-Clause
 %
 % Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/reference/generate_bianchi.m ns-3.43/src/wifi/examples/reference/generate_bianchi.m
--- ns-3.42/src/wifi/examples/reference/generate_bianchi.m	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/reference/generate_bianchi.m	2024-10-09 16:41:10.112656800 -0700
@@ -1,30 +1,6 @@
 % Copyright 2020 University of Washington
 %
-% Redistribution and use in source and binary forms, with or without
-% modification, are permitted provided that the following conditions are met:
-%
-% 1. Redistributions of source code must retain the above copyright notice,
-% this list of conditions and the following disclaimer.
-%
-% 2. Redistributions in binary form must reproduce the above copyright notice,
-% this list of conditions and the following disclaimer in the documentation
-% and/or other materials provided with the distribution.
-%
-% 3. Neither the name of the copyright holder nor the names of its contributors
-% may be used to endorse or promote products derived from this software without
-% specific prior written permission.
-%
-% THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
-% AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-% IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-% ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
-% LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
-% CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
-% SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
-% INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
-% CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
-% ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
-% POSSIBILITY OF SUCH DAMAGE.
+% SPDX-License-Identifier: BSD-3-Clause
 %
 % Co-authored by Leonardo Lanante, Hao Yin, and Sebastien Deronne
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/wifi-bianchi.cc ns-3.43/src/wifi/examples/wifi-bianchi.cc
--- ns-3.42/src/wifi/examples/wifi-bianchi.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/wifi-bianchi.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2012 The Boeing Company
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Gary Pei <guangyu.pei@boeing.com>
  *
@@ -2410,9 +2399,9 @@
      * \param pcap flag to enable/disable PCAP files generation
      * \param infra flag to enable infrastructure model, ring adhoc network if not set
      * \param guardIntervalNs the guard interval in ns
-     * \param distanceM the distance in meters
-     * \param apTxPowerDbm the AP transmit power in dBm
-     * \param staTxPowerDbm the STA transmit power in dBm
+     * \param distance the distance
+     * \param apTxPower the AP transmit power
+     * \param staTxPower the STA transmit power
      * \param pktInterval the packet interval
      * \return 0 if all went well
      */
@@ -2426,9 +2415,9 @@
             bool pcap,
             bool infra,
             uint16_t guardIntervalNs,
-            double distanceM,
-            double apTxPowerDbm,
-            double staTxPowerDbm,
+            meter_u distance,
+            dBm_u apTxPower,
+            dBm_u staTxPower,
             Time pktInterval);
 };
 
@@ -2447,9 +2436,9 @@
                 bool pcap,
                 bool infra,
                 uint16_t guardIntervalNs,
-                double distance,
-                double apTxPowerDbm,
-                double staTxPowerDbm,
+                meter_u distance,
+                dBm_u apTxPower,
+                dBm_u staTxPower,
                 Time pktInterval)
 {
     RngSeedManager::SetSeed(10);
@@ -2471,7 +2460,7 @@
     phy.SetPcapDataLinkType(WifiPhyHelper::DLT_IEEE802_11_RADIO);
 
     WifiMacHelper mac = wifiMac;
-    WifiHelper wifi = helper;
+    const auto& wifi = helper;
     NetDeviceContainer devices;
     uint32_t nNodes = wifiNodes.GetN();
     if (infra)
@@ -2485,8 +2474,8 @@
                     TimeValue(MicroSeconds(beaconInterval)),
                     "Ssid",
                     SsidValue(ssid));
-        phy.Set("TxPowerStart", DoubleValue(apTxPowerDbm));
-        phy.Set("TxPowerEnd", DoubleValue(apTxPowerDbm));
+        phy.Set("TxPowerStart", DoubleValue(apTxPower));
+        phy.Set("TxPowerEnd", DoubleValue(apTxPower));
         devices = wifi.Install(phy, mac, wifiNodes.Get(0));
 
         mac.SetType("ns3::StaWifiMac",
@@ -2494,8 +2483,8 @@
                     UintegerValue(std::numeric_limits<uint32_t>::max()),
                     "Ssid",
                     SsidValue(ssid));
-        phy.Set("TxPowerStart", DoubleValue(staTxPowerDbm));
-        phy.Set("TxPowerEnd", DoubleValue(staTxPowerDbm));
+        phy.Set("TxPowerStart", DoubleValue(staTxPower));
+        phy.Set("TxPowerEnd", DoubleValue(staTxPower));
         for (uint32_t i = 1; i < nNodes; ++i)
         {
             devices.Add(wifi.Install(phy, mac, wifiNodes.Get(i)));
@@ -2504,12 +2493,12 @@
     else
     {
         mac.SetType("ns3::AdhocWifiMac");
-        phy.Set("TxPowerStart", DoubleValue(staTxPowerDbm));
-        phy.Set("TxPowerEnd", DoubleValue(staTxPowerDbm));
+        phy.Set("TxPowerStart", DoubleValue(staTxPower));
+        phy.Set("TxPowerEnd", DoubleValue(staTxPower));
         devices = wifi.Install(phy, mac, wifiNodes);
     }
 
-    wifi.AssignStreams(devices, trialNumber);
+    WifiHelper::AssignStreams(devices, trialNumber);
 
     Config::Set(
         "/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/HtConfiguration/ShortGuardIntervalSupported",
@@ -2539,7 +2528,7 @@
     positionAlloc->Add(Vector(1.0, 1.0, 0.0));
 
     // Set position for STAs
-    double angle = (static_cast<double>(360) / (nNodes - 1));
+    const auto angle = (static_cast<degree_u>(360) / (nNodes - 1));
     for (uint32_t i = 0; i < (nNodes - 1); ++i)
     {
         positionAlloc->Add(Vector(1.0 + (distance * cos((i * angle * PI) / 180)),
@@ -2716,9 +2705,9 @@
     uint16_t pktInterval =
         1000; ///< The socket packet interval in microseconds (a higher value is needed to reach
               ///< saturation conditions as the channel bandwidth or the MCS increases)
-    double distance = 0.001; ///< The distance in meters between the AP and the STAs
-    double apTxPower = 16;   ///< The transmit power of the AP in dBm (if infrastructure only)
-    double staTxPower = 16;  ///< The transmit power of each STA in dBm (or all STAs if adhoc)
+    meter_u distance = 0.001; ///< The distance in meters between the AP and the STAs
+    dBm_u apTxPower = 16;     ///< The transmit power of the AP (if infrastructure only)
+    dBm_u staTxPower = 16;    ///< The transmit power of each STA (or all STAs if adhoc)
 
     // Disable fragmentation and RTS/CTS
     Config::SetDefault("ns3::WifiRemoteStationManager::FragmentationThreshold",
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/examples/wifi-manager-example.cc ns-3.43/src/wifi/examples/wifi-manager-example.cc
--- ns-3.42/src/wifi/examples/wifi-manager-example.cc	2024-05-29 15:29:47.196073800 -0700
+++ ns-3.43/src/wifi/examples/wifi-manager-example.cc	2024-10-09 16:41:10.112656800 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2016 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Tom Henderson <tomhend@u.washington.edu>
  *          Matías Richart <mrichart@fing.edu.uy>
@@ -46,6 +35,7 @@
 // --broadcast instead of unicast (default is unicast)
 // --rtsThreshold (by default, value of 99999 disables it)
 
+#include "ns3/attribute-container.h"
 #include "ns3/boolean.h"
 #include "ns3/command-line.h"
 #include "ns3/config.h"
@@ -73,10 +63,6 @@
 
 NS_LOG_COMPONENT_DEFINE("WifiManagerExample");
 
-// 290K @ 20 MHz
-const double NOISE_DBM_Hz = -174.0; //!< Default value for noise.
-double noiseDbm = NOISE_DBM_Hz;     //!< Value for noise.
-
 double g_intervalBytes = 0;  //!< Bytes received in an interval.
 uint64_t g_intervalRate = 0; //!< Rate in an interval.
 
@@ -108,7 +94,7 @@
 /// Step structure
 struct Step
 {
-    double stepSize; ///< step size in dBm
+    dBm_u stepSize;  ///< step size
     double stepTime; ///< step size in seconds
 };
 
@@ -136,9 +122,9 @@
     StandardInfo(std::string name,
                  WifiStandard standard,
                  WifiPhyBand band,
-                 uint16_t width,
-                 double snrLow,
-                 double snrHigh,
+                 MHz_u width,
+                 dB_u snrLow,
+                 dB_u snrHigh,
                  double xMin,
                  double xMax,
                  double yMax)
@@ -157,9 +143,9 @@
     std::string m_name;      ///< name
     WifiStandard m_standard; ///< standard
     WifiPhyBand m_band;      ///< PHY band
-    uint16_t m_width;        ///< channel width
-    double m_snrLow;         ///< lowest SNR
-    double m_snrHigh;        ///< highest SNR
+    MHz_u m_width;           ///< channel width
+    dB_u m_snrLow;           ///< lowest SNR
+    dB_u m_snrHigh;          ///< highest SNR
     double m_xMin;           ///< X minimum
     double m_xMax;           ///< X maximum
     double m_yMax;           ///< Y maximum
@@ -169,20 +155,22 @@
  * Change the signal model and report the rate.
  *
  * \param rssModel The new RSS model.
- * \param step The step tp use.
+ * \param step The step to use.
  * \param rss The RSS.
+ * \param noise The noise.
  * \param rateDataset The rate dataset.
  * \param actualDataset The actual dataset.
  */
 void
 ChangeSignalAndReportRate(Ptr<FixedRssLossModel> rssModel,
                           Step step,
-                          double rss,
+                          dBm_u rss,
+                          dBm_u noise,
                           Gnuplot2dDataset& rateDataset,
                           Gnuplot2dDataset& actualDataset)
 {
     NS_LOG_FUNCTION(rssModel << step.stepSize << step.stepTime << rss);
-    double snr = rss - noiseDbm;
+    dB_u snr = rss - noise;
     rateDataset.Add(snr, g_intervalRate / 1e6);
     // Calculate received rate since last interval
     double currentRate = ((g_intervalBytes * 8) / step.stepTime) / 1e6; // Mb/s
@@ -197,6 +185,7 @@
                         rssModel,
                         step,
                         (rss - step.stepSize),
+                        noise,
                         rateDataset,
                         actualDataset);
 }
@@ -209,7 +198,7 @@
     uint32_t steps;
     uint32_t rtsThreshold = 999999; // disabled even for large A-MPDU
     uint32_t maxAmpduSize = 65535;
-    double stepSize = 1;        // dBm
+    dBm_u stepSize = 1;
     double stepTime = 1;        // seconds
     uint32_t packetSize = 1024; // bytes
     bool broadcast = false;
@@ -639,46 +628,43 @@
     NetDeviceContainer serverDevice;
     NetDeviceContainer clientDevice;
 
-    TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue> channelValue;
+    AttributeContainerValue<
+        TupleValue<UintegerValue, UintegerValue, EnumValue<WifiPhyBand>, UintegerValue>,
+        ';'>
+        channelValue;
 
     WifiMacHelper wifiMac;
     if (infrastructure)
     {
         Ssid ssid = Ssid("ns-3-ssid");
         wifiMac.SetType("ns3::StaWifiMac", "Ssid", SsidValue(ssid));
-        channelValue.Set(WifiPhy::ChannelTuple{0,
-                                               serverSelectedStandard.m_width,
-                                               serverSelectedStandard.m_band,
-                                               0});
+        channelValue.Set(WifiPhy::ChannelSegments{
+            {0, serverSelectedStandard.m_width, serverSelectedStandard.m_band, 0}});
         wifiPhy.Set("ChannelSettings", channelValue);
         serverDevice = wifi.Install(wifiPhy, wifiMac, serverNode);
 
         wifiMac.SetType("ns3::ApWifiMac", "Ssid", SsidValue(ssid));
-        channelValue.Set(WifiPhy::ChannelTuple{0,
-                                               clientSelectedStandard.m_width,
-                                               clientSelectedStandard.m_band,
-                                               0});
+        channelValue.Set(WifiPhy::ChannelSegments{
+            {0, clientSelectedStandard.m_width, clientSelectedStandard.m_band, 0}});
+        wifiPhy.Set("ChannelSettings", channelValue);
         clientDevice = wifi.Install(wifiPhy, wifiMac, clientNode);
     }
     else
     {
         wifiMac.SetType("ns3::AdhocWifiMac");
-        channelValue.Set(WifiPhy::ChannelTuple{0,
-                                               serverSelectedStandard.m_width,
-                                               serverSelectedStandard.m_band,
-                                               0});
+        channelValue.Set(WifiPhy::ChannelSegments{
+            {0, serverSelectedStandard.m_width, serverSelectedStandard.m_band, 0}});
         wifiPhy.Set("ChannelSettings", channelValue);
         serverDevice = wifi.Install(wifiPhy, wifiMac, serverNode);
 
-        channelValue.Set(WifiPhy::ChannelTuple{0,
-                                               clientSelectedStandard.m_width,
-                                               clientSelectedStandard.m_band,
-                                               0});
+        channelValue.Set(WifiPhy::ChannelSegments{
+            {0, clientSelectedStandard.m_width, clientSelectedStandard.m_band, 0}});
+        wifiPhy.Set("ChannelSettings", channelValue);
         clientDevice = wifi.Install(wifiPhy, wifiMac, clientNode);
     }
 
-    wifi.AssignStreams(serverDevice, 100);
-    wifi.AssignStreams(clientDevice, 200);
+    WifiHelper::AssignStreams(serverDevice, 100);
+    WifiHelper::AssignStreams(clientDevice, 200);
 
     Config::Set("/NodeList/*/DeviceList/*/$ns3::WifiNetDevice/Mac/BE_MaxAmpduSize",
                 UintegerValue(maxAmpduSize));
@@ -741,13 +727,16 @@
         wndServer->GetHeConfiguration()->SetGuardInterval(NanoSeconds(serverShortGuardInterval));
         wndClient->GetHeConfiguration()->SetGuardInterval(NanoSeconds(clientShortGuardInterval));
     }
-    NS_LOG_DEBUG("Channel width " << wifiPhyPtrClient->GetChannelWidth() << " noiseDbm "
-                                  << noiseDbm);
-    NS_LOG_DEBUG("NSS " << wifiPhyPtrClient->GetMaxSupportedTxSpatialStreams());
 
     // Configure signal and noise, and schedule first iteration
-    noiseDbm += 10 * log10(clientSelectedStandard.m_width * 1000000);
-    double rssCurrent = (clientSelectedStandard.m_snrHigh + noiseDbm);
+    const auto BOLTZMANN = 1.3803e-23;
+    const dBm_per_Hz_u noiseDensity = WToDbm(BOLTZMANN * 290); // 290K @ 20 MHz
+    const dBm_u noise = noiseDensity + (10 * log10(clientSelectedStandard.m_width * 1000000));
+
+    NS_LOG_DEBUG("Channel width " << wifiPhyPtrClient->GetChannelWidth() << " noise " << noise);
+    NS_LOG_DEBUG("NSS " << wifiPhyPtrClient->GetMaxSupportedTxSpatialStreams());
+
+    const dBm_u rssCurrent = (clientSelectedStandard.m_snrHigh + noise);
     rssLossModel->SetRss(rssCurrent);
     NS_LOG_INFO("Setting initial Rss to " << rssCurrent);
     // Move the STA by stepsSize meters every stepTime seconds
@@ -756,6 +745,7 @@
                         rssLossModel,
                         step,
                         rssCurrent,
+                        noise,
                         rateDataset,
                         actualDataset);
 
